unit Newtli;

interface

uses
  TCalls, NwCalls, TIPXSPX, TTLI, NWTLI, NwIPXSPX, TNet, NWNet, NWTypes, NWConst,NWConst2,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

const
  BUF_SIZE = 65528;
  TLI_PORT = 31;
type

  {Fonctions d'evenements}
  TDataAvailable = procedure (Sender: TObject; Socket: word) of object;
  TSessionClosed = procedure (Sender: TObject; Socket: word) of object;
  TSessionAvailable = procedure (Sender: TObject; Socket: word) of object;
  TSessionConnected = procedure (Sender: TObject; Socket: word) of object;
  TSessionConnectedError = procedure (Sender: TObject; Socket: word) of object;

  TNWTLI = class(TComponent)
  private
    FAbout: String;
    Fbid: String;
    FLSocket: integer;    {Ecoute}
    spx_addr:  IPX_ADDR;   {Structure IPX}
    TCall:      t_callRec;     {}
    TBind:      t_BindRec;     {}
    spx_Options:   SPX_Opts;   {Options des SPX}
    FTimer: TTimer;
    Fbuf: Pchar;
    SockList: TList;           {Liste des connections qui sont ouvertes}
    FDataAvailable: TDataAvailable;
    FSessionClosed: TSessionClosed;
    FSessionAvailable: TSessionAvailable;
    FSessionConnected: TSessionConnected;
    FSessionConnectedError: TSessionConnectedError;
    procedure TLI_Timer(Sender: TObject);
    procedure Close;
    procedure PutAddress(str: PChar; buf: PChar; hexBytes: integer);
    procedure Look;
    procedure kill (sock: word);
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Connect(NetWork: String;Node: String): boolean;
    function Listen: boolean;
    function  Disconnect (sock: word): Boolean;
    function Send(sock: word;str: array of char;longueur: word): boolean;
    function Read(sock: word;var str: array of char;var longueur: word): boolean;
  published
    property about: String read FAbout write FBid;
    property OnDataAvailable: TDataAvailable read FDataAvailable write FDataAvailable;
    property OnSessionClosed: TSessionClosed read FSessionClosed write FSessionClosed;
    property OnSessionAvailable: TSessionAvailable read FSessionAvailable write FSessionAvailable;
    property OnSessionConnected: TSessionConnected read FSessionConnected write FSessionConnected;
    property OnSessionConnectedError: TSessionConnectedError read FSessionConnectedError write FSessionConnectedError;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Projet Novell', [TNWTLI]);
end;

{modifie}
constructor TNWTLI.Create(AOwner: TComponent);
var
  i: integer;
begin
  inherited Create(AOwner);

  FAbout:='Projet NOVELL (All player:) David, Eric, Tanguy';
  FLSocket := -1;
  SockList:=TList.Create;
  Ftimer:= TTimer.Create(Self);
  Ftimer.Enabled:=False;
  try
     GetMem (FBuf,BUF_SIZE);
   except
     on EOutOfMemory do {erreur mais bon...};
   end;
end;

{modifie}
destructor TNWTLI.Destroy;
var
    i:integer;
begin
  CLose;
  freeMem (FBuf,BUF_SIZE);
  FTimer.destroy;
  SockList.Free;
  inherited Destroy;
end;

procedure TNWTLI.Close;
var
    i:integer;
begin
  if FLSocket <> -1 then
  begin
    t_unbind (FLSocket);
    t_close(FLSocket);
    FLSocket := -1;
  end;
  for i:=0 to SockList.count-1 do
  begin
     if i<=SockList.count-1 then kill (i);
  end;
end;

procedure TNWTLI.kill (sock: word);
var
  socket: word;
begin
    if (sock<SockList.count) then
    begin
        socket:=Pword(SockList.Items[sock])^;
        if socket<>$ffff then
        begin
           t_unbind (socket);
           t_close(socket);
           freeMem(SockList.Items[sock],2);
           SockList.delete(sock);
        end;
    end;
end;

{modifie}
function TNWTLI.Connect(NetWork: String;Node: String): boolean;
var
  ch: array [0..20] of char;
  ch1: array [0..20] of char;
  i:integer;
  pt: ^Word;
begin
  StrPcopy (ch,NetWork);
  PutAddress (ch,ch1,4);
  for i:=0 to 3 do
     spx_addr.ipxa_net[i]:=byte(ch1[i]);

  StrPcopy (ch,Node);
  PutAddress (ch,ch1,6);
  for i:=0 to 5 do
     spx_addr.ipxa_node[i]:=byte(ch1[i]);

  {Creation d'une nouvelle Socket}
  GetMem (pt,2);
  SockList.add(pt);

  {ouverture d'une socket}
  pt^ := t_open('/dev/nspx',O_RDWR or O_NDELAY, nil);
  if pt^ = -1 then
  begin
    t_error('Connect: t_open erreur');
    result:=False;
    exit;
  end;

  {Bind de la socket}
  if t_bind(pt^,nil,nil) = -1 then
  begin
    t_error('Connect: t_bind erreur');
    result:=False;
    exit;
  end;

  spx_addr.ipxa_socket[0]:=byte(TLI_PORT shr 8);
  spx_addr.ipxa_socket[1]:=byte(TLI_PORT and $FF);

  tcall.addr.buf := @spx_addr;
  tcall.addr.len := sizeof(spx_addr);
  tcall.addr.maxlen := sizeof(spx_addr);
  spx_options.spx_connectionID[0] := $0;
  spx_options.spx_connectionID[1] := $0;
  spx_options.spx_allocationNumber[0] := $0;
  spx_options.spx_allocationNumber[1] := $0;
  tcall.opt.buf := @spx_options;
  tcall.opt.len := sizeof(spx_options);
  tcall.opt.maxlen := sizeof(spx_options);
  tcall.udata.buf := nil;
  tcall.udata.len := 0;
  tcall.udata.maxlen := 0;

  {On se connecte}
  if t_connect(pt^,@tcall,@tcall) = -1 then
  begin
{     t_error('Connect: t_connect erreur');
     result:=False;
     exit;}
  end;

  {On declanche un Timer pour regader l'etat de la socket}
  Ftimer.Interval:=100;
  Ftimer.OnTimer:=TLI_Timer;
  Ftimer.Enabled := True;

  result:=True;
end;

{modifie}
function TNWTLI.Listen: boolean;
begin
  Close;

  {ouverture d'une socket}
  FLSocket := t_open('/dev/nspx',O_RDWR or O_NDELAY, nil);
  if FLSocket = -1 then
  begin
    t_error('Connect: t_open erreur');
    result:=False;
    exit;
  end;

  {Bind de la socket}
  spx_addr.ipxa_socket[0] := byte(TLI_PORT shr 8);
  spx_addr.ipxa_socket[1] := byte(TLI_PORT and $ff);

  tbind.addr.len := sizeof(spx_addr);
  tbind.addr.maxlen := sizeof(spx_addr);
  tbind.addr.buf := @spx_addr;
  tbind.qlen := 5;
  if t_bind(FLSocket,@tbind,@tbind) = -1 then
  begin
    t_error('Connect: t_bind erreur');
    result:=False;
    exit;
  end;

  tcall.addr.buf := @spx_addr;
  tcall.addr.len := sizeof(spx_addr);
  tcall.addr.maxlen := sizeof(spx_addr);
  spx_options.spx_connectionID[0] := $0;
  spx_options.spx_connectionID[1] := $0;
  spx_options.spx_allocationNumber[0] := $0;
  spx_options.spx_allocationNumber[1] := $0;
  tcall.opt.buf := @spx_options;
  tcall.opt.len := sizeof(spx_options);
  tcall.opt.maxlen := sizeof(spx_options);
  tcall.udata.buf := nil;
  tcall.udata.len := 0;
  tcall.udata.maxlen := 0;

  {On declanche un Timer pour regader l'etat de la socket}
  Ftimer.Interval:=100;
  Ftimer.OnTimer:=TLI_Timer;
  Ftimer.Enabled := True;
end;

procedure TNWTLI.TLI_Timer(Sender: TObject);
var
  LookEvent: integer;
  pt: ^word;
  pos: integer;
begin
  if FLSocket <> -1 then   {En ecoute}
  begin
     LookEvent := t_look(FLSocket);
     case LookEvent of
     _T_LISTEN:
        begin
           if t_listen(FLSocket,@tcall) = -1 then
          begin
              t_error('Poll: t_listen erreur');
              exit;
           end;
           {Creation d'une nouvelle Socket}
           GetMem (pt,2);
           pos:=SockList.add(pt);

          {ouverture d'une socket pour emmission avec la personne qui vient de communiquer}
           pt^ := t_open('/dev/nspx',O_RDWR , nil);
           if pt^ = -1 then
           begin
              t_error('Connect: t_open erreur');
             exit;
           end;

           {Bind de la socket}
           if t_bind(pt^,nil,nil) = -1 then
          begin
              t_error('Connect: t_bind erreur');
              exit;
           end;

          {On accepte la socket et on l'utilise pour repondre (TCall)}
           if t_accept(FLSocket,pt^,@Tcall) = -1 then
           begin
              t_error('Connect: t_accept erreur');
              exit;
          end;

           if assigned(FSessionAvailable) then
              FSessionAvailable(Self,pos);
       end;
     end;
  end;

  {En envoie}
  look;

end;

procedure TNWTLI.Look;
var
    i:integer;
    FSSocket: word;
    LookEvent: integer;
begin
    for i:=0 to SockList.count-1 do
    begin
     if i<=SockList.count-1 then
     begin
        FSSocket:=Pword(SockList.Items[i])^;

        if FSSocket <> $ffff then
        begin
            LookEvent := t_look(FSSocket);
            case LookEvent of
             T_DATA:
                begin
                   if assigned(FDataAvailable) then
                     FDataAvailable(Self,i);
               end;
             _T_CONNECT:
                begin
                   if t_rcvconnect(FSSocket,@tcall) = 0 then
                   if assigned(FSessionConnected) then
                      FSessionConnected(Self,i);
               end;
             T_DISCONNECT:
                begin
                   if (t_rcvdis(FSSocket, NIL) = 0) then
                   begin
                        if assigned(FSessionClosed) then
                            FSessionClosed(Self,i);
                   end
                   else
                        if assigned(FSessionConnectedError) then FSessionConnectedError(Self,i);
                   kill(i);
                end;
             end;
          end;
        end;
    end;
end;

function TNWTLI.Disconnect (sock: word): Boolean;
var
    pt: ^word;
begin
  result:=false;
  if sock<SockList.count then
  begin
    pt:=SockList.Items[sock];
    if pt^<>$ffff then
    begin
        if t_snddis(pt^,@tcall) = -1 then
            t_error('Disconnect: t_snddis failed')
        else
        begin
            kill (sock);
            result:=True;
        end;
    end;
  end;
end;

function TNWTLI.Send(sock: word; str: array of char ;longueur: word): boolean;
var
    pt: ^word;
begin
  result:=False;
  if sock<SockList.count then
  begin
    pt:=SockList.Items[sock];
    if pt^<>$ffff then
    begin
        if t_snd(pt^,@(str[0]),longueur,0) = -1 then
            t_error('Text (Set): t_snd failed')
        else
            result:=True;
    end;
  end;
end;


function TNWTLI.Read(sock: word; var str: array of char;var longueur: word): boolean;
var
  pt: ^word;
  flags: integer;
begin
  result:=False;
  if sock<SockList.count then
  begin
    pt:=SockList.Items[sock];
    if pt^<>$ffff then
    begin
        flags:=0;
        longueur := t_rcv(pt^,@(str[0]),BUF_SIZE,@flags);
        if longueur < 0 then
            t_error('Text (Get): t_rcv failed')
        else
            result:=True;
    end;
  end;
end;

procedure TNWTli.PutAddress(str: PChar; buf: PChar; hexBytes: integer);
var
  i,j,n,value: integer;
  c: char;
begin
  StrUpper(str);
  n := 0;
  for i:=0 to hexBytes-1 do
  begin
    value := 0;
    for j:=0 to 1 do
    begin
      value := value shl 4;
      if (str[n] >= '0') and (str[n] <= '9') then
        value := value + ord(str[n]) - $30;
      if (str[n] >= 'A') and (str[n] <= 'F') then
        value := value + ord(str[n]) - $41 + 10;
      inc(n);
    end;
  buf[i] := char(value);
  end;
end;


end.
