unit NLMUti;

interface

uses TCalls, Forms;

type
    TEvNWTLI = class
        procedure NWTLIDataAvailable(Sender: TObject; Socket: Word);
        procedure NWTLISessionConnected(Sender: TObject; Socket: Word);
        procedure NWTLISessionClosed(Sender: TObject; Socket: Word);
        procedure NWTLISessionConnectedError(Sender: TObject; Socket: Word);
    end;

procedure InitialisationNLM(Sender: TForm; HServerNet, HServerNode: String);
procedure FinNLM;
function ConnexionNLM: Boolean;
function ActiveNLM(MotDePasse: String): Boolean;
procedure ArreteNLM;
function CreateObject(conn: word; objectName: Pchar; objectType: word; objectFlags: byte; objectSecurity: byte): word;
function ScanObject(conn: word; searchName: Pchar; searchType: word; objectID: Plongint; objectName: Pchar;
                    objectType: Pword; hasPropertiesFlag: Pbyte; objectFlags: Pbyte; objectSecurity: Pbyte): word;
function DeleteObject(conn: word; objectName: Pchar; objectType: word): word;
function VerifyObjectPassword(conn: word; objectName: Pchar; objectType: word; password: Pchar): word;
function ChangeObjectPassword(conn: word; objectName: Pchar; objectType: word; oldPassword: Pchar; newPassword: Pchar): word;
function DisallowObjectPassword(conn: word; objectName: Pchar; objectType: word; disallowedPassword: Pchar): word;
function ScanProperty(conn: word;	objectName: Pchar; objectType: word; searchPropertyName: Pchar;
                        sequenceNumber: Plongint; propertyName: Pchar; propertyFlags: Pbyte; propertySecurity: Pbyte;
                        hasValueFlag: Pbyte; moreFlag: Pbyte): word;
function CreateProperty(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar; propertyFlags: byte;
            propertySecurity: byte): word;
function RenameObject(conn: word; oldObjectName: Pchar; newObjectName: Pchar; objectType: word): word;
function ChangeObjectSecurity(conn: word; objectName: Pchar; objectType: word; newObjectSecurity: byte): word;
function GetObjectName(conn: word; objectID: longint; objectName: Pchar; objectType: Pword): word;
function IsObjectInSet(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar;
                        memberName: Pchar; memberType: word): word;
function DeleteObjectFromSet(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar;
                        memberName: Pchar; memberType: word): word;
function AddObjectToSet(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar; memberName: Pchar;
                        memberType: word): word;
function DeleteProperty(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar): word;
function ReadPropertyValue(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar; segmentNumber: byte;
                            segmentData: Pbyte; moreSegments: Pbyte; flags: Pbyte): word;
function WritePropertyValue(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar; segmentNumber: byte;
                                segmentData: Pbyte; moreSegments: byte): word;
function ScanObjectTrusteePaths(conn: word; objectID: longint; volNumber: word; sequenceNumber: Pword; accessRights: Pbyte;
	                                dirPath: Pchar): word;
function DeleteTrusteeFromDirectory(conn: word; dirHandle: byte; dirPath: Pchar; objectID: longint): word;
function AddTrusteeToDirectory(conn: word; dirHandle: byte; dirPath: Pchar; trusteeID: longint; rightsMask: byte): word;


implementation

uses NWCalls, Boite11, NewTli, Dialogs, SysUtils;


var SocketNLM: Word;
    NWTLI: TNWTLI;
    EvNWTLI: TEvNWTLI;
    ServerNet, ServerNode: String;
    Dump: array[0..1000] of char;
    CompteurDump: Word;
    PPassword: PChar;

const UtiNLM: Boolean = False;
       DataAvailable: Boolean = False;
       ConnecteNLM: Boolean = False;

{************************ E V E N N E M E N T   D U   N W T L I **********************************************************}
procedure TEvNWTLI.NWTLIDataAvailable(Sender: TObject; Socket: Word);
begin
    DataAvailable := True;
end;

procedure TEvNWTLI.NWTLISessionConnected(Sender: TObject; Socket: Word);
begin
    SocketNLM := Socket;
    ConnecteNLM := True;
    if FormConnectNLM.Visible then FormConnectNLM.Close;
end;

procedure TEvNWTLI.NWTLISessionConnectedError(Sender: TObject; Socket: Word);
begin
    ConnecteNLM := False;
    if FormConnectNLM.Visible then FormConnectNLM.Close;
end;

procedure TEvNWTLI.NWTLISessionClosed(Sender: TObject; Socket: Word);
begin
    ConnecteNLM := False;
    UtiNLM := False;
end;

{***************************************** I N T E R N E ********************************************************************}
{ Lecture dans Dump}
procedure LireLongInt(var Ret: LongInt);
begin
    move(Dump[CompteurDump], Ret, 4);
    Ret := NWLongSwap(Ret);
    CompteurDump := CompteurDump + 4;
end;

procedure LireWord(var Ret: Word);
begin
    move(Dump[CompteurDump], Ret, 2);
    Ret := NWWordSwap(Ret);
    CompteurDump := CompteurDump + 2;
end;

procedure LireByte(var Ret: Byte);
begin
    move(Dump[CompteurDump], Ret, 1);
    CompteurDump := CompteurDump + 1;
end;

procedure LirePChar(Ret: PChar);
var Compteur: Word;
begin
    Compteur := 0;
    while (Dump[CompteurDump + Compteur] <> #0) do Inc(Compteur);
    move(Dump[CompteurDump], Ret[0], Compteur + 1);
    CompteurDump := CompteurDump + Compteur + 1;
end;

procedure LirePpteValue(Buffer: PByte);
begin
    move(Dump[CompteurDump], Buffer^, 128);
    CompteurDump := CompteurDump + 128;
end;

function VerifPassword: Boolean;
var Ret: Byte;
begin
    CompteurDump := 0;
    LireByte(Ret);
    Result := (Ret = 0);
end;

{Ecriture dans Dump}
procedure EcrireLongInt(Ret: LongInt);
begin
    Ret := NWLongSwap(Ret);
    move(Ret, Dump[CompteurDump], 4);
    CompteurDump := CompteurDump + 4;
end;

procedure EcrireWord(Ret: Word);
begin
    Ret := NWWordSwap(Ret);
    move(Ret, Dump[CompteurDump], 2);
    CompteurDump := CompteurDump + 2;
end;

procedure EcrireByte(Ret: Byte);
begin
    move(Ret, Dump[CompteurDump], 1);
    CompteurDump := CompteurDump + 1;
end;

procedure EcrirePChar(Ret: PChar);
var Taille: Integer;
begin
    Taille := StrLen(Ret)+1;
    move(Ret[0], Dump[CompteurDump], Taille);
    CompteurDump := CompteurDump + Taille;
end;

procedure EcrirePpteValue(Buffer: PByte);
begin
    move(Buffer^, Dump[CompteurDump], 128);
    CompteurDump := CompteurDump + 128;
end;

procedure EcrireFonction(Fonction: Word);
begin
    CompteurDump := 0;
    EcrirePChar(PPassword);
    move(Fonction, Dump[CompteurDump], 2);
    CompteurDump := CompteurDump + 2;
end;

{procedure d'envoi et de reception}
procedure NWTLISend;
begin
    NWTLI.Send(SocketNLM, Dump, CompteurDump);
end;

function NWTLIRead: Word;
var Taille: Word;
begin
    while ((not DataAvailable) and UtiNLM) do Application.ProcessMessages;
    if not UtiNLM then
    begin
        MessageDlg('Arret du NLM Magic en pleine lecture !', mtError, [mbOK], 0);
        Halt;
    end;
    DataAvailable := False;
    NWTLI.Read(SocketNLM, Dump, Taille);
    Result := Taille;
end;

{************************************ E X P O R T E ***********************************************}
procedure InitialisationNLM(Sender: TForm; HServerNet, HServerNode: String);
begin
    GetMem(PPassword, 256);
    ServerNet := HServerNet;
    ServerNode := HServerNode;
    NWTLI := TNWTLI.Create(Sender);
    EvNWTLI := TEvNWTLI.Create;
    NWTLI.OnDataAvailable := EvNWTLI.NWTLIDataAvailable;
    NWTLI.OnSessionConnected := EvNWTLI.NWTLISessionConnected;
    NWTLI.OnSessionClosed := EvNWTLI.NWTLISessionClosed;
    NWTLI.OnSessionConnectedError := EvNWTLI.NWTLISessionConnectedError;
end;

procedure FinNLM;
begin
    if ConnecteNLM then NWTLI.DisConnect(SocketNLM);
    EvNWTLI.Free;
    NWTLI.Free;
    FreeMem(PPassword, 256);
end;

function ConnexionNLM: Boolean;
begin
    if not ConnecteNLM then
    if NWTLI.Connect(ServerNet, ServerNode) then
    begin
        FormConnectNLM.ShowModal;
        if not ConnecteNLM then
            MessageDlg('Le NLM ne doit pas tre charg sur le server', mtError, [mbOK], 0);
    end;
    Result := ConnecteNLM;
end;

{ Active le NLM (avec verif du mot de passe) }
function ActiveNLM(MotDePasse: String): Boolean;
begin
    if not ConnecteNLM then Exit;
    StrPCopy(PPassword, MotDePasse);
    EcrireFonction(1);
    UtiNLM := True;
    NWTLISend;
    NWTLIRead;
    UtiNLM := VerifPassword;
    Result := UtiNLM;
end;


procedure ArreteNLM;
begin
    UtiNLM := False;
end;


{ TNWBindery }
function CreateObject(conn: word; objectName: Pchar; objectType: word; objectFlags: byte; objectSecurity: byte): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(2);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrireByte(objectFlags);
        EcrireByte(objectSecurity);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWCreateObject(conn, objectName, objectType, objectFlags, objectSecurity);
end;


function ScanObject(conn: word; searchName: Pchar; searchType: word; objectID: Plongint; objectName: Pchar;
                    objectType: Pword; hasPropertiesFlag: Pbyte; objectFlags: Pbyte; objectSecurity: Pbyte): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(3);
        EcrirePChar(searchName);
        EcrireWord(searchType);
        EcrireLongInt(objectID^);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
        begin
            LireWord(Result);
            if (Result = 0) then
            begin
                LireLongInt(objectID^);
                LirePChar(objectName);
                LireWord(objectType^);
                LireByte(hasPropertiesFlag^);
                LireByte(objectFlags^);
                LireByte(objectSecurity^);
            end;
        end
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWScanObject(conn, searchName, searchType, Pointer(objectID), objectName, Pointer(objectType),
                                Pointer(hasPropertiesFlag), Pointer(objectFlags), Pointer(objectSecurity));
end;

{ TNWObject }
function DeleteObject(conn: word; objectName: Pchar; objectType: word): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(4);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWDeleteObject(conn, objectName, objectType);
end;


function VerifyObjectPassword(conn: word; objectName: Pchar; objectType: word; password: Pchar): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(5);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrirePChar(Password);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWVerifyObjectPassword(conn, objectName, objectType, password);
end;


function ChangeObjectPassword(conn: word; objectName: Pchar; objectType: word; oldPassword: Pchar; newPassword: Pchar): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(6);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrirePChar(oldPassword);
        EcrirePChar(newPassword);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWChangeObjectPassword(conn, objectName, objectType, oldPassword, newPassword);
end;


function DisallowObjectPassword(conn: word; objectName: Pchar; objectType: word; disallowedPassword: Pchar): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(7);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrirePChar(disallowedPassword);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
	    Result := NWDisallowObjectPassword(conn, objectName, objectType, disallowedPassword);
end;


function ScanProperty(conn: word; objectName: Pchar; objectType: word; searchPropertyName: Pchar;
                        sequenceNumber: Plongint; propertyName: Pchar; propertyFlags: Pbyte; propertySecurity: Pbyte;
                        hasValueFlag: Pbyte; moreFlag: Pbyte): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(8);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrirePChar(searchPropertyName);
        EcrireLongInt(sequenceNumber^);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
        begin
            LireWord(Result);
            if (Result = 0) then
            begin
                LireLongInt(sequenceNumber^);
                LirePChar(propertyName);
                LireByte(propertyFlags^);
                LireByte(propertySecurity^);
                LireByte(hasValueFlag^);
                LireByte(moreFlag^);
            end;
        end
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWScanProperty(conn, objectName, objectType, searchPropertyName, Pointer(sequenceNumber), propertyName,
                                    Pointer(propertyFlags), Pointer(propertySecurity), Pointer(hasValueFlag),
                                    Pointer(moreFlag));
end;


function CreateProperty(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar; propertyFlags: byte;
            propertySecurity: byte): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(9);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrirePChar(propertyName);
        EcrireByte(propertyFlags);
        EcrireByte(propertySecurity);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWCreateProperty(conn, objectName, objectType, propertyName, propertyFlags, propertySecurity);
end;


function RenameObject(conn: word; oldObjectName: Pchar; newObjectName: Pchar; objectType: word): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(10);
        EcrirePChar(oldObjectName);
        EcrirePChar(newObjectName);
        EcrireWord(objectType);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWRenameObject(conn, oldObjectName, newObjectName, objectType);
end;


function ChangeObjectSecurity(conn: word; objectName: Pchar; objectType: word; newObjectSecurity: byte): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(11);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrireByte(newObjectSecurity);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWChangeObjectSecurity(conn, objectName, objectType, newObjectSecurity);
end;


function GetObjectName(conn: word; objectID: longint; objectName: Pchar; objectType: Pword): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(12);
        EcrireLongInt(objectID);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
        begin
            LireWord(Result);
            if (Result = 0) then
            begin
                LirePChar(objectName);
                LireWord(objectType^);
            end;
        end
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWGetObjectName(conn, objectID, objectName, Pointer(objectType));
end;

{ TNWPropriete }

function IsObjectInSet(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar;
                        memberName: Pchar; memberType: word): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(13);
        EcrirePChar(ObjectName);
        EcrireWord(objectType);
        EcrirePChar(propertyName);
        EcrirePChar(memberName);
        EcrireWord(memberType);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWIsObjectInSet(conn, objectName, objectType, propertyName, memberName, memberType);
end;

function DeleteObjectFromSet(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar;
                        memberName: Pchar; memberType: word): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(14);
        EcrirePChar(ObjectName);
        EcrireWord(objectType);
        EcrirePChar(propertyName);
        EcrirePChar(memberName);
        EcrireWord(memberType);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWDeleteObjectFromSet(conn, objectName, objectType, propertyName, memberName, memberType);
end;


function AddObjectToSet(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar; memberName: Pchar;
                            memberType: word): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(15);
        EcrirePChar(ObjectName);
        EcrireWord(objectType);
        EcrirePChar(propertyName);
        EcrirePChar(memberName);
        EcrireWord(memberType);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWAddObjectToSet(conn, objectName, objectType, propertyName, memberName, memberType);
end;


function DeleteProperty(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(16);
        EcrirePChar(ObjectName);
        EcrireWord(objectType);
        EcrirePChar(propertyName);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWDeleteProperty(conn, objectName, objectType, propertyName);
end;


function ReadPropertyValue(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar; segmentNumber: byte;
                            segmentData: Pbyte; moreSegments: Pbyte; flags: Pbyte): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(17);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrirePChar(propertyName);
        EcrireByte(segmentNumber);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
        begin
            LireWord(Result);
            if (Result = 0) then
            begin
                LirePpteValue(segmentData);
                LireByte(moreSegments^);
                LireByte(flags^);
            end;
        end
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWReadPropertyValue(conn, objectName, objectType, propertyName, segmentNumber, Pointer(segmentData),
                                        Pointer(moreSegments), Pointer(flags));
end;


function WritePropertyValue(conn: word; objectName: Pchar; objectType: word; propertyName: Pchar; segmentNumber: byte;
                                segmentData: Pbyte; moreSegments: byte): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(18);
        EcrirePChar(objectName);
        EcrireWord(objectType);
        EcrirePChar(propertyName);
        EcrireByte(segmentNumber);
        EcrirePpteValue(segmentData);
        EcrireByte(moreSegments);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWWritePropertyValue(conn, objectName, objectType, propertyName, segmentNumber, Pointer(segmentData),
                                        moreSegments);
end;


{ Trustees }
function ScanObjectTrusteePaths(conn: word; objectID: longint; volNumber: word; sequenceNumber: Pword; accessRights: Pbyte;
	                                dirPath: Pchar): word;
var Temp: Byte;
begin
    if UtiNLM then
    begin
        EcrireFonction(19);
        Temp := VolNumber;
        EcrireLongInt(objectID);
        EcrireByte(Temp);
        if (sequenceNumber^ = $FFFF) then sequenceNumber^ := 0;
        EcrireWord(sequenceNumber^);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
        begin
            LireWord(Result);
            if (Result = 0) then
            begin
                LireWord(sequenceNumber^);
                LireByte(accessRights^);
                LireByte(Temp);
                LirePChar(dirPath);
            end;
        end
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWScanObjectTrusteePaths(conn, objectID, volNumber, Pointer(sequenceNumber), Pointer(accessRights),
                                            Pointer(dirPath));
end;


function DeleteTrusteeFromDirectory(conn: word; dirHandle: byte; dirPath: Pchar; objectID: longint): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(20);
        EcrirePChar(dirPath);
        EcrireLongInt(objectID);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWDeleteTrusteeFromDirectory(conn, dirHandle, dirPath, objectID);
end;


function AddTrusteeToDirectory(conn: word; dirHandle: byte; dirPath: Pchar; trusteeID: longint; rightsMask: byte): word;
begin
    if UtiNLM then
    begin
        EcrireFonction(21);
        EcrirePChar(dirPath);
        EcrireLongInt(trusteeID);
        EcrireByte(rightsMask);
        EcrireByte(0);
        NWTLISend;
        NWTLIRead;
        if VerifPassword then
            LireWord(Result)
        else
            UtiNLM := False;
    end;
    if not UtiNLM then
        Result := NWAddTrusteeToDirectory(conn, dirHandle, dirPath, trusteeID, rightsMask);
end;

end.
