unit NwTli;

interface

uses TTLI;

function t_accept (
         fd: integer;
         resfd: integer;
         call: Pt_call): integer;

function t_alloc (
         fd: integer;
         struct_type: integer;
         fields: integer): Pchar;

function t_bind (
         fd: integer;
         req: Pt_bind;
         ret: Pt_bind): integer;

function t_blocking (
         fd: integer): integer;

function t_close (
         fd: integer): integer;

function t_connect (
         fd: integer;
         sndcall: Pt_call;
         rcvcall: Pt_call): integer;

procedure t_error (
          errmsg: Pchar);

function terrno_func: integer;

function t_free (
         ptr: Pchar;
         struct_type: integer): integer;

function t_getinfo (
         fd: integer;
         info: Pt_info): integer;

function t_getstate (
         fd: integer): integer;

function t_listen (
         fd: integer;
         call: Pt_call): integer;

function t_look (
         fd: integer): integer;

function t_nonblocking (
         fd: integer): integer;

function t_open (
         path: Pchar;
               oflag: integer;
               info: Pt_info): integer;

function t_optmgmt (
         fd: integer;
         req: Pt_optmgmt;
         ret: Pt_optmgmt): integer;

function t_rcv (
         fd: integer;
         buf: Pchar;
         nbytes: word;
         flags: Pinteger): integer;

function t_rcvconnect (
         fd: integer;
         call: Pt_call): integer;

function t_rcvdis (
         fd: integer;
         discon: Pt_discon): integer;

function t_rcvrel (
         fd: integer): integer;

function t_rcvudata (
         fd: integer;
         unitdata: Pt_unitdata;
         flags: Pinteger): integer;

function t_rcvuderr (
         fd: integer;
         uderr: Pt_uderr): integer;

function t_snd (
         fd: integer;
         buf: Pchar;
         nbytes: word;
         flags: integer): integer;

function t_snddis (
         fd: integer;
         call: Pt_call): integer;

function t_sndrel (
         fd: integer): integer;

function t_sndudata (
         fd: integer;
         unitdata: Pt_unitdata): integer;

function t_sync (
         fd: integer): integer;

function t_unbind (
         fd: integer): integer;

implementation

{function ERROR_SHIM; external 'tli_win' index 0025;}
{function WEP     ; external 'tli_win' index 0001;}
{function ___EXPORTEDSTUB; external 'tli_tcp' index 0013;}
function T_LISTEN; external 'tli_win' index     8;
{function TLI_REALLOC; external 'tli_win' index    31;}
function T_SNDDIS; external 'tli_win' index    20;
function T_ALLOC ; external 'tli_win' index    35;
function T_BLOCKING; external 'tli_win' index    25;
function T_SNDREL; external 'tli_win' index    21;
function T_RCVDIS; external 'tli_win' index    14;
function T_RCVREL; external 'tli_win' index    15;
function TERRNO_FUNC; external 'tli_win' index    28;
function T_RCVCONNECT; external 'tli_win' index    13;
function T_UNBIND; external 'tli_win' index    24;
function T_CLOSE ; external 'tli_win' index     4;
function T_LOOK  ; external 'tli_win' index     9;
function T_OPEN  ; external 'tli_win' index     2;
function T_SYNC  ; external 'tli_win' index    23;
{function POLL    ; external 'tli_win' index    36;}
{function TLI_ALLOC; external 'tli_win' index    29;}
function T_CONNECT; external 'tli_win' index     5;
function T_SNDUDATA; external 'tli_win' index    22;
{function TLI_FREE; external 'tli_win' index    32;}
function T_RCVUDATA; external 'tli_win' index    16;
function T_ACCEPT; external 'tli_win' index    10;
{function T_EVENT ; external 'tli_win' index    27;}
procedure T_ERROR ; external 'tli_win' index    33;
function T_SND   ; external 'tli_win' index    18;
function T_GETSTATE; external 'tli_win' index     7;
function T_RCV   ; external 'tli_win' index    12;
function T_GETINFO; external 'tli_win' index     6;
function T_BIND  ; external 'tli_win' index     3;
function T_RCVUDERR; external 'tli_win' index    17;
{function TLI_CALLOC; external 'tli_win' index    30;}
function T_FREE  ; external 'tli_win' index    34;
function T_NONBLOCKING; external 'tli_win' index    26;
function T_OPTMGMT; external 'tli_win' index    11;

end.
