unit TNWSvrFi;

interface

uses Classes,
        TNWObj;

type
    TNWServeurFichier = class(TNWObject)
    private
        { Private-dclarations }
    protected
        { Protected-dclarations }
    public
        { Public-dclarations }
        procedure ChercheOperateurs(Operateurs: TStrings);
        procedure AssignOperateurs(Operateurs: TStrings);
        function ChercheAdresseNet: String;
    end;

implementation

uses TNWPpte, SysUtils;

procedure TNWServeurFichier.ChercheOperateurs(Operateurs: TStrings);
begin
    ChercheObjectsDansSet(Operateurs, 'OPERATORS');
end;

procedure TNWServeurFichier.AssignOperateurs(Operateurs: TStrings);
begin
    AssignObjectsDansSet('OPERATORS', Operateurs);
end;


function TNWServeurFichier.ChercheAdresseNet: String;
var Dump: String[128];
    Resultat: String[26];
    PpteAdresseNet: TNWPropriete;
    Compteur: Integer;
begin
    PpteAdresseNet := TNWPropriete.Create(Self, 'NET_ADDRESS', 0, 0, 0);
    Dump := PpteAdresseNet.PpteValeurs[1];
    if (Dump[0] = #0) then Resultat:='????????????????????????'
    else
    begin
        Resultat := '';
        for Compteur:=1 to 12 do Resultat := Resultat + IntToHex(Byte(Dump[Compteur]), 2);
    end;
    Insert(':', Resultat, 21);
    Insert(':', Resultat, 9);
    PpteAdresseNet.Free;
    Result := Resultat;
end;

end.
