unit Nwconn;

interface

uses
  TCalls, NwCalls, TIPXSPX, TTLI, NWTLI, NwIPXSPX, TNet, NWNet, NWTypes, NWConst,NWConst2,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TNWConn = class(TComponent)
  private
    { Private-dclarations }
    FServerName: String;     {Nom du serveur}
    FServerNet: array [0..3] of char;  {addresse du serveur}
    FServerNode:array [0..5] of char;  {node du serveur}
    FUserName: String;           {Nom de l'utilisateur}
    FUserNet: array [0..3] of char;  {addresse du client}
    FUserNode:array [0..5] of char;  {node du client}
    FHandle: word;           {Handle de connection}
    FConnNumber: word;       {Numero de connection sur Novell}
    procedure BidWord (toto: word);
    procedure BidString (toto: String);
    procedure info;
    function GetUserNet: Pchar;
    function GetUserNode: Pchar;
    function GetServerNet: Pchar;
    function GetServerNode: Pchar;
    function GetHUserNet: String;
    function GetHUserNode: String;
    function GetHServerNet: String;
    function GetHServerNode: String;
  protected
    { Protected-dclarations }
  public
    { Public-dclarations }
    constructor Create (Aowner: Tcomponent); override;
    destructor Destroy; override;
    function Attach (server: string): Boolean;
    function Detach : Boolean;
    function login (User: string;Passwd: string): Boolean;
    function logout : Boolean;
    property UserNet: Pchar read GetUserNet;
    property UserNode: Pchar read GetUserNode;
    property ServerNet: Pchar read GetServerNet;
    property ServerNode: Pchar read GetServerNode;
  published
    { Published-dclarations }
    property ServerName: string read FServerName write BidString;
    property UserName: string read FUserName write BidString;
    property Handle: word read FHandle write BidWord;
    property ConnNumber: word read FConnNumber write BidWord;
    property HUserNet: String read GetHUserNet write BidString;
    property HUserNode: String read GetHUserNode write BidString;
    property HServerNet: String read GetHServerNet write BidString;
    property HServerNode: String read GetHServerNode write BidString;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Projet Novell', [TNWConn]);
end;                

constructor TNWConn.Create(AOwner: TComponent);
  var
  ccode: NWCCODE;

begin
  inherited Create(AOwner);
  {Initialisation des fonctions NetWare}
  ccode:=NWCallsInit(NIL,NIL);
  if (ccode<>0) then
  begin
    exit;
  end;
  info;
end;

destructor TNWConn.Destroy;
begin
  inherited Destroy;
end;

procedure TNWConn.BidWord (toto: word);
begin
  {Procedure bidon}
end;

procedure TNWConn.BidString (toto: string);
begin
  {Procedure bidon}
end;

procedure TNWConn.info;
var
  ccode: NWCCODE;
  info: Connect_Info;
  InetAddr: NWINET_ADDR;
begin
  FHandle:=0;
  FServerName:='';
  FUserName:='';
  FConnNumber:=0;
  Fillchar(FServerNet,4,0);
  Fillchar(FServerNode,6,0);
  Fillchar(FUserNet,4,0);
  Fillchar(FUserNode,6,0);

  {Obtenir le numero de conection}
  ccode := NWGetDefaultConnectionID(@FHandle);
  if (ccode<>0) then
  begin
    FHandle:=0;
    exit;
  end;

  {Obtenir le status courant de la connection}
  ccode := NWGetConnectionStatus  (FHandle,@info,sizeof(info));
  if (ccode<>0) then
  begin
    FHandle:=0;
    exit;
  end;

  if ((info.connectflags and CONNECTION_NDS) <> 0) or
     ((info.connectflags and CONNECTION_LOGGED_IN) <> 0) then
  begin
     {deja logged}
     FUserName := strpas (info.ClientName);
     FConnNumber := info.ConnNumber;

     {Obtenir l'addresse de la machine}
     ccode:=NWGetInetAddr(FHandle,FConnNumber,@InetAddr);
     if (ccode<>0) then
     begin
        FHandle:=0;
        exit;
     end;
     move (inetaddr.networkAddr,FUserNet,4);
     move (inetaddr.netNodeAddr,FUserNode,6);
  end;

  {Information sur le File Serveur}
  FServerName := strpas (info.ServerName);

  move (info.ServerAddr,FServerNet,4);
  move (info.ServerAddr[4],FServerNode,6);

end;

{ Changer de File SERVER}
function TNWConn.Attach (server: string): Boolean;
var
  ccode: NWCCODE;
  StrServer: array [0..49] of char;
begin
  result := True;

  ccode:=NWAttachToFileServer(StrPCopy(StrServer,UpperCase(server)),0,@FHandle);
  if (ccode<>0) then
  begin
    {On n'a pas reussi! snif}
    Result:=False;
  end;
  info;
end;

{Se detacher d'un File SERVER}
function TNWConn.Detach : Boolean;
var
  ccode: NWCCODE;
begin
  result := True;
  ccode:=NWDetachFromFileServer(FHandle);
  if (ccode<>0) then
  begin
    {On n'a pas reussi! snif}
    Result:=False;
  end;
  info;
end;

function TNWConn.login (User: string;Passwd: string): Boolean;
var
  ccode: NWCCODE;
  StrUser:  array [0..49] of char;
  StrPasswd: array [0..49] of char;
begin
  result := True;
  ccode:=NWLoginToFileServer(FHandle,StrPCopy(StrUser,UpperCase(User)),
                             OT_USER,StrPCopy(StrPasswd,UpperCase(Passwd)));
  if (ccode<>0) then
  begin
    Result:=False;
  end;
  info;
end;

function TNWCOnn.logout : Boolean;
var
  ccode: NWCCODE;
begin
  result := True;
  ccode:=NWLogoutFromFileServer (FHandle);
  if (ccode<>0) then
  begin
    Result:=False;
  end;
  info;
end;

function TNWConn.GetUserNet: Pchar;
begin
  result:=FUserNet;
end;

function TNWConn.GetUserNode: Pchar;
begin
  result:=FUserNode;
end;

function TNWConn.GetServerNet: Pchar;
begin
  result:=FServerNet;
end;

function TNWConn.GetServerNode: Pchar;
begin
  result:=FServerNode;
end;

function TNWConn.GetHUserNet: String;
begin
  result:=InttoHex(longint(UserNet[0]),2) +
          InttoHex(longint(UserNet[1]),2) +
          InttoHex(longint(UserNet[2]),2) +
          InttoHex(longint(UserNet[3]),2);
end;

function TNWConn.GetHUserNode: String;
begin
  result:=InttoHex(longint(UserNode[0]),2)+
          InttoHex(longint(UserNode[1]),2)+
          InttoHex(longint(UserNode[2]),2)+
          InttoHex(longint(UserNode[3]),2)+
          InttoHex(longint(UserNode[4]),2)+
          InttoHex(longint(UserNode[5]),2);
end;

function TNWConn.GetHServerNet: String;
begin
  result:=InttoHex(longint(ServerNet[0]),2) +
          InttoHex(longint(ServerNet[1]),2) +
          InttoHex(longint(ServerNet[2]),2) +
          InttoHex(longint(ServerNet[3]),2);
end;

function TNWConn.GetHServerNode: String;
begin
  result:=InttoHex(longint(ServerNode[0]),2)+
          InttoHex(longint(ServerNode[1]),2)+
          InttoHex(longint(ServerNode[2]),2)+
          InttoHex(longint(ServerNode[3]),2)+
          InttoHex(longint(ServerNode[4]),2)+
          InttoHex(longint(ServerNode[5]),2);
end;

end.
